pyrdbg
=======

**THIS IS A NIGHTLY PRE_BUILD FOR THE TEST OF THE BUILD CHAIN.**

The **pyrdbg** - *Python Remote Debugging* - package provides extensions for the integrated remote debugging of Python programs
in hybrid *Cloud* and *IoT* environments via *SSH* with:

* *PyDev* and *Eclipse*
* *Pycharm* community + professional - available soon
* *VisualStudio* - available soon
* *VSCode* - available soon

For details refer to the online documentation.

The supported platforms are:

* Linux, BSD, Unix, OS-X, Cygwin, and Windows

* x86, amd64, arm32/armhf, arm64/aarch64

* Servers, Workstations, Embedded Systems

* Datacenters, public and private Clouds, IoT 

Integrates seamless with *SSH-TOOLS* for multi-agent key management.

For details refer to the online documents.

**Online documentation**:

* https://pyrdbg.sourceforge.io/

**Runtime-Repository**:

* PyPI: https://pypi.org/project/pyrdbg/

  Install: *pip install pyrdbg*, see also 'Install'.


**Downloads**:

* sourceforge.net: https://sourceforge.net/projects/pyrdbg/files/

* bitbucket.org: https://bitbucket.org/acue/pyrdbg

* github.com: https://github.com/ArnoCan/pyrdbg/

* pypi.org: https://pypi.org/project/pyrdbg/


Project Data
------------

* PROJECT: 'pyrdbg'

* MISSION: Provide easy access to remote debugging in hybrid *Cloud* and *IoT* environments with *PyDev* and *Eclipse* via *SSH*.

* VERSION: 00.02

* RELEASE: 00.02.020

* STATUS: alpha

* AUTHOR: Arno-Can Uestuensoez

* COPYRIGHT: Copyright (C) 2008-2019 Arno-Can Uestuensoez @Ingenieurbuero Arno-Can Uestuensoez

* LICENSE: Artistic-License-2.0 + Forced-Fairplay-Constraints

Concepts and enumeration values are migrated from the 

* *UnifiedSessionsManager* (C) 2008 Arno-Can Uestuensoez @Ingenieurbuero Arno-Can Uestuensoez.  

to *ePyUnit* and finally as *pyRDBG*.

Runtime Environment
-------------------
For a comprehensive list refer to the documentation.

**Python Syntax Support**

*  Python2.7, and Python3

**Python Implementation Support**

*  CPython, IPython, IronPython, Jython, and PyPy

**OS on Server, Workstation, Laptops, Virtual Machines, and Containers**

* Linux: AlpineLinux, ArchLinux, CentOS, Debian, Fedora, Gentoo, OpenSUSE, Raspbian, RHEL, Slackware, SLES, Ubuntu, ...  

* BSD: DragonFlyBSD, FreeBSD, NetBSD, OpenBSD, GhostBSD, TrueOS, NomadBSD

* OS-X: Snow Leopard

* Windows: Win10, Win8.1, Win7, WinXP, Win2019, Win2016, Win2012, Win2008, Win2000

* WSL-1.0: Alpine, Debian, KaliLinux, openSUSE, SLES, Ubuntu

* Cygwin

* UNIX: Solaris10, Solaris11

* Minix: Minix3

* ReactOS

**Network and Security**

* Network Devices: OpenWRT(LinkSys, Zyxel)

* Security: KaliLinux, pfSense, BlackArch, ParrotOS, Pentoo

**OS on Embedded Devices**

* RaspberryPI: ArchLinux, CentOS, OpenBSD, OpenWRT, Raspbian

* ASUS-TinkerBoard: Armbian

* e.g. Adafruit Trinket M0: CircuitPython, MicroPython

Current Release
---------------

The quality of the implemented features is appropriate for productive Python development with *beta* or better,
some final features such as multi-ide support are coming soon.
Therefore this is one of the final overall *alpha* releases, switching to overall *beta* soon.

Major Changes:

* Initial version.

* Concepts and enumeration values migrated from the *UnifiedSessionsManager* (C) 2008 Arno-Can Uestuensoez,
  starting at 2007/2008
  
  See docs@ctys.sourceforge.io - https://ctys.sourceforge.io/.

ToDo:

* test OpenBSD on rpi3

* test Windows10IoT-Core

* PyCharm-Community - with external third-party debug probe

* PyCharm-Professional - with external third-party and provided debug probe

* MS-VisualStudio

* MS-VSCode

