#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""Command line wrapper for rdbg.
"""
from __future__ import absolute_import
from __future__ import print_function


__author__ = 'Arno-Can Uestuensoez'
__license__ = "Artistic-License-2.0 + Forced-Fairplay-Constraints"
__copyright__ = "Copyright (C) 2010-2018 Arno-Can Uestuensoez" \
                " @Ingenieurbuero Arno-Can Uestuensoez"
__version__ = '0.1.1'
__uuid__ = '7f464182-b723-4e6e-869d-80a16b9cfaca'

__docformat__ = "restructuredtext en"


# debug
import sys
if '--debug' in sys.argv:
    sys.stderr.write('\nDEMO:sys.executable = %s\n' % (str(sys.executable)))

    from platformids.platforms import PlatformParameters
    
    platfrm = PlatformParameters()
    platfrm.scan()
    
    print(platfrm)

#    for x in platfrm.items():
    for x in sorted(platfrm):
        print(x)
    
    for x in sorted(platfrm.items()):
        print(x)

    import os
    sys.stderr.write('\nDEMO:sys.version    = [\n')
    for x in sys.version.split(os.linesep):
        sys.stderr.write('DEMO:sys.version    :   %s\n' % (x))
    sys.stderr.write('DEMO:sys.version    : ]\n' )

    sys.stderr.write('\nDEMO:sys.argv       = [\n' )
    for x in sys.argv:
        sys.stderr.write('DEMO:sys.argv       :   %s\n' % (x))
    sys.stderr.write('DEMO:sys.argv       : ]\n' )

    sys.stderr.write('\nDEMO:sys.path       = [\n' )
    for x in sys.path:
        sys.stderr.write('DEMO:sys.path       :   %s\n' % (x))
    sys.stderr.write('DEMO:sys.path       : ]\n' )

    sys.stderr.write('\n' )

    import platform
    sys.stderr.write('\nDEMO:platform.node = %s\n' % (str(platform.node())))
    sys.stderr.write('\n' )

#
# Checks 'sys.argv' for '--rdbg', if present, 
# than loads and executes 'rdbg'. 
# For help use options '-h' or '--rdbg-help'.
#
from rdbg.start import start_remote_debug
start_remote_debug()

if '--debug' in sys.argv:
    from rdbg.shared import PYDEVD
    sys.stderr.write('\npydevd            = %s\n' % (str(PYDEVD.pydevd)))
    sys.stderr.write('\n' )

